openshot::Pixelate Class Reference

This class pixelates an image, and can be animated with openshot::Keyframe curves over time. More...

`#include <Pixelate.h>`

Inheritance diagram for openshot::Pixelate:

## Public Member Functions

std::shared_ptr< Frame > | GetFrame (std::shared_ptr< Frame > frame, int64_t frame_number)
| This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object. More...
string | Json ()
| Get and Set JSON methods. More...
Json::Value | JsonValue ()
| Generate Json::JsonValue for this object. More...
| Pixelate ()
| Blank constructor, useful when using Json to load the effect properties. More...
| Pixelate (Keyframe pixelization, Keyframe left, Keyframe top, Keyframe right, Keyframe bottom)
string | PropertiesJSON (int64_t requested_frame)
void | SetJson (string value)
| Load JSON string into this object. More...
void | SetJsonValue (Json::Value root)
| Load Json::JsonValue into this object. More...
Public Member Functions inherited from openshot::EffectBase
int | constrain (int color_value)
| Constrain a color value from 0 to 255. More...
void | DisplayInfo ()
| Display effect information in the standard output stream (stdout) More...
void | InitEffectInfo ()
Json::Value | JsonInfo ()
| Generate JSON object of meta data / info. More...
int | Order ()
| Get the order that this effect should be executed. More...
void | Order (int new_order)
| Set the order that this effect should be executed. More...
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip. More...
void | Id (string value)
| Set basic properties. More...
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
void | SetMaxSize (int width, int height)
| Set Max Image Size (used for performance optimization) More...

## Public Attributes

Keyframe | bottom
| Size of bottom margin. More...
Keyframe | left
| Size of left margin. More...
Keyframe | pixelization
| Amount of pixelization. More...
Keyframe | right
| Size of right margin. More...
Keyframe | top
| Size of top margin. More...
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect. More...

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (string name, int value, int selected_value)
| Generate JSON choice for a property (dropdown properties) More...
Json::Value | add_property_json (string name, float value, string type, string memo, Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame)
| Generate JSON for a property. More...
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip) More...
string | id
| ID Property for all derived Clip and Effect classes. More...
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips. More...
int | max_height
| The maximium image height needed by this clip (used for optimizations) More...
int | max_width
| The maximum image width needed by this clip (used for optimizations) More...
float | position
| The position on the timeline where this clip should start playing. More...
string | previous_properties
| This string contains the previous JSON properties. More...
float | start
| The position in seconds to start playing (used to trim the beginning of a clip) More...

## Detailed Description

This class pixelates an image, and can be animated with openshot::Keyframe curves over time.

Pixelating the image is the process of increasing the size of visible pixels, thus loosing visual clarity of the image. The area to pixelate can be set and animated with keyframes also.

Definition at line 52 of file Pixelate.h.

## Constructor & Destructor Documentation

## Pixelate() [1/2]

Pixelate::Pixelate | ( |  | ) |

Blank constructor, useful when using Json to load the effect properties.

Definition at line 33 of file Pixelate.cpp.

## Pixelate() [2/2]

Pixelate::Pixelate | ( | Keyframe | pixelization,
|  | Keyframe | left,
|  | Keyframe | top,
|  | Keyframe | right,
|  | Keyframe | bottom
| ) |  |

Default constructor, which takes 5 curves. These curves animate the pixelization effect over time.

Parameters

  pixelization | The curve to adjust the amount of pixelization (0 to 1)
  left | The curve to adjust the left margin size (between 0 and 1)
  top | The curve to adjust the top margin size (between 0 and 1)
  right | The curve to adjust the right margin size (between 0 and 1)
  bottom | The curve to adjust the bottom margin size (between 0 and 1)

Definition at line 39 of file Pixelate.cpp.

## Member Function Documentation

## GetFrame()

std::shared_ptr< Frame > Pixelate::GetFrame | ( | std::shared_ptr< Frame > | frame,
|  | int64_t | frame_number
| ) |  |

virtual

This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object.

The frame object is passed into this method, and a frame_number is passed in which tells the effect which settings to use from it's keyframes (starting at 1).

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the effect applied to it
  frame_number | The frame number (starting at 1) of the effect on the timeline.

Implements openshot::EffectBase.

Definition at line 62 of file Pixelate.cpp.

## Json()

string Pixelate::Json | ( |  | ) |

virtual

Get and Set JSON methods.

Generate JSON string of this object

Implements openshot::EffectBase.

Definition at line 110 of file Pixelate.cpp.

## JsonValue()

Json::Value Pixelate::JsonValue | ( |  | ) |

virtual

Generate Json::JsonValue for this object.

Implements openshot::EffectBase.

Definition at line 117 of file Pixelate.cpp.

## PropertiesJSON()

string Pixelate::PropertiesJSON | ( | int64_t | requested_frame | ) |

virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 175 of file Pixelate.cpp.

## SetJson()

void Pixelate::SetJson | ( | string | value | ) |

virtual

Load JSON string into this object.

Implements openshot::EffectBase.

Definition at line 133 of file Pixelate.cpp.

## SetJsonValue()

void Pixelate::SetJsonValue | ( | Json::Value | root | ) |

virtual

Load Json::JsonValue into this object.

Implements openshot::EffectBase.

Definition at line 156 of file Pixelate.cpp.

## Member Data Documentation

## bottom

Keyframe openshot::Pixelate::bottom

Size of bottom margin.

Definition at line 64 of file Pixelate.h.

## left

Keyframe openshot::Pixelate::left

Size of left margin.

Definition at line 61 of file Pixelate.h.

## pixelization

Keyframe openshot::Pixelate::pixelization

Amount of pixelization.

Definition at line 60 of file Pixelate.h.

## right

Keyframe openshot::Pixelate::right

Size of right margin.

Definition at line 63 of file Pixelate.h.

## top

Keyframe openshot::Pixelate::top

Size of top margin.

Definition at line 62 of file Pixelate.h.

The documentation for this class was generated from the following files:

- Pixelate.h
- Pixelate.cpp